//fonr chip io define    GT30L16
sbit GTSCK      =    P1^7;    // LCD RS ADD Font chip Serial clock input
sbit GTSI    =   	P1^5;    // LCD WR OR W/R ADD Font chip Serial data input
sbit GTSO     =  	P1^6;    // LCD RD OR E ADD Font chip Serial data output
sbit GTCS        =   	P3^5;    //  Font  Chip enable input

#define  SPI_Read( ) 	SPI_Trsend_Ch(0xff)


#define uint unsigned int
#define uchar unsigned char

uchar xdata fontbuf[32];





//********************************************************************************************************

void Display_One_Chinese_8X16(unsigned int y,unsigned int x,unsigned char ft1[],unsigned int dcolor,unsigned int bgcolor)
{  
	unsigned char i,j,temp;  
    LCD_SetPos(x,x+7,y,y+15);  
	Write_Data(bgcolor>>8,bgcolor);
	   
	for(j=0;j<16;j++)
	{temp=ft1[j];
		for(i=0;i<8;i++)
		{ 		     
		 	if(temp&0x80)
			{
				Write_Data(dcolor>>8,dcolor);
			} 
			else
			{
				Write_Data(bgcolor>>8,bgcolor);
			} 
  		temp<<=1;
		}
		
	 }
}

void Display_One_Chinese_16X16(unsigned int y,unsigned int x,unsigned char ft1[],unsigned int dcolor,unsigned int bgcolor)

{  
	unsigned char i,j,temp;  
    LCD_SetPos(x,x+15,y,y+15);        
	Write_Data(bgcolor>>8,bgcolor);
	for(j=0;j<32;j++)
	{temp=ft1[j];
		for(i=0;i<8;i++)
		{ 		     
		 	if(temp&0x80)
			{
				Write_Data(dcolor>>8,dcolor);
			} 
			else
			{
				Write_Data(bgcolor>>8,bgcolor);
			} 
  		temp<<=1;
		}
		
	 }
}





//-------------------------------------------------
static unsigned char spi_trsend_ch_mode0( unsigned char datu )
{
	unsigned char cnt_clk;
	unsigned char temp;
	unsigned char ret_datu;

	for( cnt_clk = 0; cnt_clk < 8; cnt_clk++ )
	{
		GTSCK=0;
		ret_datu = ret_datu<<1;
		GTSO=1;
		if( GTSO )
			ret_datu |= 0x01;
		else
			ret_datu &= 0xfe;

		temp = datu&0x80;
		if( temp > 0 )
			GTSI = 1;
		else
			GTSI = 0;
		datu = datu<<1;
		GTSCK   =  1;

	}
	return(ret_datu);
}
//--------------------------------------------------------------------------------
static unsigned char SPI_Trsend_Ch( unsigned char SendData )
{
	return( spi_trsend_ch_mode0(SendData) );
}
//--------------------------------------------------------------------------------
static void SPI_Address(unsigned char AddH,unsigned char AddM,unsigned char AddL)
{
	GTCS = 0;
	SPI_Trsend_Ch(0x03);
	SPI_Trsend_Ch(AddH);
	SPI_Trsend_Ch(AddM);
	SPI_Trsend_Ch(AddL);

}
//------------------------------------------------------------------------------

unsigned char readbyte(unsigned long addr)  //read one byte from GT ROM
{uchar addrHigh, addrMid, addrLow,ret_data;	
	addrHigh = (addr&0xff0000)>>16;
	addrMid = (addr&0x00ff00)>>8;
	addrLow = addr&0x0000ff;
	SPI_Address(addrHigh,addrMid,addrLow);
	ret_data = SPI_Read();
	GTCS = 1;
	return(ret_data);
}
//=================================================================
//read data
//=================================================================
//-------------------------------------------------------------------------------
void GT_Read_n_1( unsigned char *pBuff,unsigned long DataAddress,unsigned char DataLen )
{
	unsigned char i;
	for(i = 0; i < DataLen; i++ )
	   *(pBuff+i) =  readbyte(DataAddress+i);
}
//=================================================================
//read data
//=================================================================


GT_Read_1_n(unsigned long DataAddress,uchar *pBuff,uchar DataLen )
{
	unsigned char i;
	unsigned char *p = (unsigned char *)(&DataAddress);
	SPI_Address(*(p+1),*(p+2),*(p+3));
	for(i = 0; i < DataLen; i++ )
			*(pBuff+i) = SPI_Read();
	GTCS = 1;
}




//-------------------------------------------------
//Calculated lattice data address
//--------------------------------------------------
unsigned long  Unicode_Addr(unsigned int  Ucode)
{	unsigned long	Address=0,a1=0;	
	unsigned long 	GB_1516_START_ADDR = 0x0A76B8;	//chinese
	unsigned long 	ASCLL_816_START_Address = 0x1883D8;  //8*16 ASCLL 


	//CHINESE
	if(Ucode >=0x3400 && Ucode <= 0x4DB5) // UNICODE3.0 Chinese font expand section 6582 Chinese characters
	Address =(a1+Ucode-0x3400)*32+ GB_1516_START_ADDR;
 	else if(Ucode >=0x4E00 && Ucode <= 0x9FA5) // UNICODE3.0 Chinese font section 20902	 Chinese characters
	Address =(a1+Ucode-0x4E00+6582)*32+ GB_1516_START_ADDR;
	else if(Ucode >=0xFF00 && Ucode <= 0xFF5E || Ucode >=0x20 && Ucode <= 0x7E )
	{ if(Ucode ==0xFF00 || Ucode == 0x20) //Blank
		Address =(a1+27484+538)*32+ GB_1516_START_ADDR;
	  else if(Ucode >0xFF00 && Ucode <= 0xFF5E)
	  	Address = (a1+Ucode -0xFF00+27484+987)*32+ GB_1516_START_ADDR;
	  else if(Ucode >0x20 && Ucode <= 0x7E )
	  	Address = (a1+Ucode -0x20+27484+987)*32+ GB_1516_START_ADDR;
	 }
//	else if (Ucode>=0x00A1&& Ucode <=0x33D5 || Ucode>= 0xE76C && Ucode <= 0xFFE5) //Code Scope
	//Address = ZFindex(Ucode)*32+27484*32+a1+ GB_1516_START_ADDR;		 //Multiplication overflowSo take the following separate


    // 8X16 ASCLL
	if (Ucode >= 0x20 && Ucode  <= 0x7E)
	Address = (Ucode  - 0x20 ) * 16 + ASCLL_816_START_Address ;    
   
    return Address;
}




void Display_Unicode_String()
{uint code text[]={0x6df1,0x5733,0x65ed,0x65e5,0x4e1c,0x65b9,0x79d1,0x6280,0x6709,0x9650,0x516c,0x53f8,0x00};

	uchar code 	text1[]={" ER-TFT035-6  320RGB*480 DOTS"};
		uchar code 	text2[]={"EASTRISING WWW.BUYDISPLSY.COM"};
	uchar i=0; uint x=54,y=20;
  	unsigned long fontaddr;	

	while(text[i]>0x00)
	{
			fontaddr = Unicode_Addr(text[i]);  				
			GT_Read_1_n(fontaddr,fontbuf,32 );							  			
			Display_One_Chinese_16X16(y,x,fontbuf,0xf800,0x0000);			  
			i+=1;
			x+=16;
		
	}
	
	x=24;y=90;i=0;
	while(text1[i]>0x00)
	{
				fontaddr = Unicode_Addr(text1[i]);  			
				GT_Read_1_n(fontaddr,fontbuf,16 );							  		
   				Display_One_Chinese_8X16(y,x,fontbuf,0xf800,0xffff);		
			i+=1;
			x+=8;
	}

	x=24;y=160;i=0;
	while(text2[i]>0x00)
	{
				fontaddr = Unicode_Addr(text2[i]);  				
				GT_Read_1_n(fontaddr,fontbuf,16 );							  		
   				Display_One_Chinese_8X16(y,x,fontbuf,0xf800,0x001f);			   
						   
			i+=1;
			x+=8;
	}
	
}









//********************************************************************************************************
